<?php

use WHMCS\View\Menu\Item as MenuItem;
use WHMCS\Database\Capsule;

define('ED_IDT','Identification Document Type');
define('ED_ID','ID Document');

function getEuroDNSConfig()
{
    require_once dirname(__FILE__).'/classEuroDNS.php';

    $result = select_query('tblregistrars', 'value', ['registrar' => 'EuroDNS', 'setting' => 'Username']);
    $data = mysql_fetch_assoc($result);
    $username = decrypt($data['value']);
    $result = select_query('tblregistrars', 'value', ['registrar' => 'EuroDNS', 'setting' => 'Password']);
    $data = mysql_fetch_assoc($result);
    $password = decrypt($data['value']);
    $result = select_query('tblregistrars', 'value', ['registrar' => 'EuroDNS', 'setting' => 'TestMode']);
    $data = mysql_fetch_assoc($result);
    $testMode = decrypt($data['value']);

    return [
        'Username' => $username,
        'Password' => $password,
        'TestMode' => $testMode,
    ];
}

function eurodns_ShoppingCartValidateDomainsConfig($vars)
{
    try {
        $attr = getEuroDNSConfig();
        $API = new EuroDNS($attr);

        foreach ($_SESSION['cart']['domains'] as $key => $domain) {
            $parts = explode('.', $domain['domain']);
            $tld = end($parts);
            unset($parts[key($parts)]);

            $params = [
                'sld' => implode('.', $parts),
                'tld' => $tld,
            ];
            $result = $API->check($params);
        }

        if (1 == $result['failed']) {
            $values['error'] = $result['reason'];
        }

        return $values;
    } catch (Exception $e) {
        //echo 'Caught exception: ',  $e->getMessage(), "\n";
    }
}

function GetDomainHelper($uID,$dID)
{
    $command = 'GetClientsDomains';
    $postData = [
        'clientid' => $uID,
        'stats' => true,
    ];

    $results = localAPI($command, $postData);

    foreach ($results['domains']['domain'] as $key => $domain) {
        if ($domain['id'] === $dID) {
            return $domain;
        }
    }

    return null;
}

function IsRegistrarEurodns($uID,$dID)
{
    $domain = GetDomainHelper($uID,$dID);

    if ($domain && 'EuroDNS' === $domain['registrar'] && class_exists('EuroDNS')) {
        return $domain;
    }

    return false;
}

function GetAdditionalFieldFromDB($dID,$fieldName)
{
    $requestId = Capsule::table('tbldomainsadditionalfields')
    ->where('domainid', $dID)->where('name',$fieldName);

    if(!$requestId->get() || count($requestId->get()) == 0)
    {
        return null;
    }

    return $requestId->get();
}

function InsertAdditionalFieldInDB($dID,$fieldName,$fieldValue)
{
    if($dID && $fieldName && $fieldValue)
    {
        try {
            $requestId = Capsule::table('tbldomainsadditionalfields')->insert(
            [
                'domainid' => $dID,
                'name' => $fieldName,
                'value' =>$fieldValue        
            ]);

            return true;
        }
        catch(Exception $exc)
        {
            return false;
        }
    }

    return null;
}

function UpdateAdditionalFieldInDB($dID,$fieldName,$fieldValue)
{
    if($dID && $fieldName && $fieldValue)
    {
        try {
            $requestId = Capsule::table('tbldomainsadditionalfields')
                ->where('domainid', $dID)
                ->where('name', $fieldName)
                ->update(
                    [
                        'value' =>$fieldValue        
                    ]);

            return true;
        }
        catch(Exception $exc)
        {
            return false;
        }
    }

    return null;
}

add_hook('ShoppingCartValidateDomainsConfig', 1, 'eurodns_ShoppingCartValidateDomainsConfig');
add_hook('ClientAreaPageDomainDNSManagement', 10, function ($vars) {

    if (IsRegistrarEurodns($vars['userid'],$vars['domainid'])) 
    {
        $formUrl = $_SERVER['PHP_SELF'].'?action=domaindns';
        $DID = end(explode('=', $vars['breadcrumb'][3]['link']));
        $token = $vars['token'];
        $parts = explode('.', $vars['breadcrumb'][3]['label']);
        $tld = end($parts);
        unset($parts[key($parts)]);
        $API = new EuroDNS(getEuroDNSConfig());
        $res = $API->zoneInfo(['sld' => implode('.', $parts), 'tld' => $tld]);
        echo $API->GetDNSForm($res, $formUrl, $token, $DID);
    }
});

add_hook('ClientAreaHeaderOutput', 1, function ($vars) {

    //if(IsRegistrarEurodns($vars['userid'],$vars['domainid']))
    //{
        $domain = $vars['domain'];
        $data = getEuroDNSConfig();
        $tld = substr($domain, strpos($domain, '.') + 1);

        $parts = explode('.', $domain);
        $API = new EuroDNS($data);

        $API->getInfo(['sld' => $parts[0], 'tld' => $tld]);

        if (!empty($API->getPendingMessage())) {
            return '<style>
            #Primary_Sidebar-Domain_Details_Management-Auto_Renew_Settings, ul.dropdown-menu.text-left.dropdown-menu-right li:nth-child(3)
            {
                display:none !important;
            }
        </style>'.$API->GetInfoMessageFrontend('Pending Action: '.$domain, 'here is some pending actions from your registrar. The information that appears on the page might be not up to date. Current action: <strong>"'.$API->getPendingMessage().'"</strong>. Some actions like changing nameservers will maybe not performed.');
        }

        return '<style>
            #Primary_Sidebar-Domain_Details_Management-Auto_Renew_Settings, ul.dropdown-menu.text-left.dropdown-menu-right li:nth-child(3)
            {
                display:none !important;
            }
        </style>';
    //}
});

add_hook('DomainEdit', 1, function ($vars) {
    if($domain = IsRegistrarEurodns($vars['userid'],$vars['domainid']))
    {
        $data = getEuroDNSConfig();
        $API = new EuroDNS($data);
        $array = explode('.', $domain['domainname'], 2);
        $data['sld'] = $array[0];
        $data['tld'] = $array[1];
        $info = $API->getInfo($data);

        if ($info) {
            $autoRenew = strtolower((string) $info->xpath('/response/resData/domain:renewal')[0]);
            $whmcsRenew = ''.$domain['donotrenew'];
            if (('autoexpire' === $autoRenew && '0' === ''.$whmcsRenew) || ('autorenew' === $autoRenew && '1' === ''.$whmcsRenew)) {
                $data['renewal'] = ('1' === $whmcsRenew ? 'autoexpire' : 'autorenew');
                $API->SetRenewalMode($data);
                logModuleCall('EuroDNS', 'auto renew change', $API->getRequest(), $API->getResponse(), null, null);
            }
        }
    }
});

add_hook('ClientAreaDomainDetailsOutput', 1, function ($vars) {
    
    if(IsRegistrarEurodns($vars['userid'],$vars['domainid']))
    {
        $domain = $vars['domain'];
        $data = getEuroDNSConfig();
        $mydomain = $domain->domain;
        $tld = substr($mydomain, strpos($mydomain, '.') + 1);
        $API = new EuroDNS($data);

        if (!$mydomain || empty($tld)) {
            return;
        }

        $tldNeed = $API->getCachedInfo(['tld', $tld, 'lockingEnabled'], true);

        if (!$tldNeed && empty($tldNeed)) {
            $infoTLD = $API->infoTld($tld);
            $tldNeed = $infoTLD['lockingEnabled'];
        }

        if ('no' === strtolower($tldNeed)) {
            return '<style>
                .alert.alert-danger, #tabOverview a[href="#tabReglock"]
                {
                    display:none !important;
                }
            </style>';
        }
    }
});

add_hook('ClientAreaPrimarySidebar', 1, function (MenuItem $primarySidebar) {
    $data = getEuroDNSConfig();
    $domain = Menu::context('domain');
    $mydomain = $domain->domain;
    $tld = substr($mydomain, strpos($mydomain, '.') + 1);

    if (!$mydomain || empty($tld)) {
        return;
    }

    $API = new EuroDNS($data);
    //logModuleCall('EuroDNS','hook:ClientAreaPrimarySidebar', json_encode($mydomain),$tld,null,null);

    $tldNeed = $API->getCachedInfo(['tld', $tld, 'lockingEnabled'], true);

    if (!$tldNeed && empty($tldNeed)) {
        $infoTLD = $API->infoTld($tld);
        $tldNeed = $infoTLD['lockingEnabled'];
    }

    if ('no' === strtolower($tldNeed)) {
        if (!is_null($primarySidebar->getChild('Domain Details Management'))) {
            $primarySidebar->getChild('Domain Details Management')
                ->removeChild('Registrar Lock Status')
            ;
        }
    }
});

add_hook('ClientAreaPageDomainEPPCode', 1, function ($vars) {
    //var_dump($GLOBALS['EPP_CODE']);
});

//add_hook('InvoicePaid', 1, function($vars) {
//    logModuleCall('EuroDNS', 'invoice paid hook', json_encode($vars) , "DEBUG", null, null);
//});

add_hook('AdminClientDomainsTabFields', 1, function($vars) {

    if((array_key_exists('userid',$_GET) && array_key_exists('id',$vars)) && ($domain = IsRegistrarEurodns($_GET['userid'],$vars['id'])))
    {
        $pos = strpos(strtolower($domain['domainname']), '.au');
        if($pos)
        {

            $addFieldT = GetAdditionalFieldFromDB($vars['id'],ED_IDT);
            $addFieldID = GetAdditionalFieldFromDB($vars['id'],ED_ID);

            if(($addFieldT instanceof Illuminate\Support\Collection) && $addFieldT->count()>0)
            {
                $addFieldT = $addFieldT->first()->value;
            }

            if(($addFieldID instanceof Illuminate\Support\Collection) && $addFieldID->count()>0)
            {
                $protocol = $_SERVER['HTTPS'] == 'on' ? 'https' : 'http';
                $baseurl = \WHMCS\Utility\Environment\WebHelper::getBaseUrl();
                $url = $protocol.'://'.$_SERVER['HTTP_HOST'].$baseurl;
                $addFieldID = '<a target="_blank" href="'.$url.'/modules/registrars/EuroDNS/uploads/'.$addFieldID->first()->value.'?.'.time().'">VIEW</a>';
            }

            return [
                ED_IDT => '<select id="doc-type-select" class="form-control w-100" name="domainfield[101]" >
                    <option value="Australian Driver Licence">Australian Driver Licence</option>
                    <option value="Australian Passport">Australian Passport</option>
                    <option value="Australian Shooter or firearm licence">Australian Shooter or firearm licence</option>
                    <option value="Australian Security Licence">Australian Security Licence</option>
                    <option value="Australian Birth Certificate">Australian Birth Certificate</option>
                    <option value="Australian permanent resident visa">Australian permanent resident visa</option>
                    <option value="Australian Citizen Certificate">Australian Citizen Certificate</option>
                    <option value="Australian Certificate of Registration by Descent">Australian Certificate of Registration by Descent</option>
                </select>',
                ED_ID => '<input id="id-doc-file" type="file" name="document" class="form-control w-100" accept="image/gif,image/jpeg,image/png,image/webp,application/pdf"/>'.$addFieldID.'
                <script>

                jQuery("#doc-type-select option[value=\"'.$addFieldT.'\"]").prop("selected",true);

                jQuery("#id-doc-file").on("change",function(elem){
                    jQuery(this).closest("form").attr("enctype","multipart/form-data");
                });
                
                </script>',
            ];
        }
    }
});

add_hook('AdminClientDomainsTabFieldsSave', 1, function($vars) {

    if(array_key_exists('userid',$vars) && array_key_exists('id',$vars) && array_key_exists('registrar',$vars) && $vars['registrar'] === 'EuroDNS')
    {
        if(array_key_exists(101,$vars['domainfield']))
        {
            $addField = GetAdditionalFieldFromDB($vars['id'],ED_IDT);
            
            if(!$addField)
            {
                InsertAdditionalFieldInDB($vars['id'],ED_IDT,$vars['domainfield'][101]);
            }
            else
            {
                UpdateAdditionalFieldInDB($vars['id'],ED_IDT,$vars['domainfield'][101]);
            }
        }


        if($_FILES && array_key_exists('document',$_FILES) && array_key_exists('tmp_name',$_FILES['document']) && array_key_exists('name',$_FILES['document']))
        {
            $file_path = dirname(__FILE__).'/uploads/';
            $fileName = $vars['userid'].'_'.$vars['id'].'.'.end(explode('.',$_FILES['document']['name']));
            
            if (!file_exists($file_path)) {
                mkdir($file_path, 0777, true);
            }

            if(move_uploaded_file($_FILES['document']['tmp_name'],$file_path.$fileName))
            {
                $addField = GetAdditionalFieldFromDB($vars['id'],ED_ID);

                if(!$addField)
                {
                    InsertAdditionalFieldInDB($vars['id'],ED_ID,$fileName);
                }
                else
                {
                    UpdateAdditionalFieldInDB($vars['id'],ED_ID,$fileName);
                }
            }
        }
    }
});


